/*
 *  Ray++ - Object-oriented ray tracing library
 *  Copyright (C) 1998-2001 Martin Reinecke and others.
 *  See the AUTHORS file for more information.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  See the README file for more information.
 */

#ifndef RAYPP_SOLID_PIGMENT_H
#define RAYPP_SOLID_PIGMENT_H

#include "kernel/kernel.h"
#include "utils/utils.h"
#include "surfaces/pigments/pigment.h"

namespace RAYPP {

class SOLID_PIGMENT: public PIGMENT
  {
  protected:
    NOISE Noise;
    float4 Turb, Lacunarity, Omega;
    int Octaves;
    COLOURMAP CMap;
    STRANSFORM Trans;

  public:
    SOLID_PIGMENT ();

    virtual void Transform (const TRANSFORM &);

    void Set_Turb (float4);
    void Set_Lacunarity (float4);
    void Set_Omega (float4);
    void Set_Octaves (uint1);
    void Set_CMap (const COLOURMAP &);
  };

} // namespace RAYPP

#endif
